<?php defined('SYSPATH') or die('No direct access allowed.');
/**
 * Widget of unacknowledged service problems for tactical overview
 *
 * @package   NINJA
 * @author    op5 AB
 * @license   GPL
 */
require_once Kohana::find_file('widgets', 'tac_services_common/tac_services_base');

class tac_services_unacknowledged_Widget extends tac_services_Base {
	private function get_all_noticed() {
		$db = new Database();
		$sql = "SELECT host_name, service_description, timestamp FROM widget_service_was_noticed";
		$ary = $db->query($sql);
		$res = array();
		foreach ($ary as $obj)
			$res[$obj->host_name.';'.$obj->service_description] = $obj->timestamp;
		return $res;
	}

	private function get_all_since_last($group)
	{
		$db = new Database();
		$last_data = isset($this->arguments['grouplog']) ? $this->arguments['grouplog'] : array();
		$result = array();
		$new_data = array();

		$shown_ary = $this->service($group, false, $this->state, $this->props, $this->order, $this->field, 'servicegroup');
		$service_ids = array();
		if ($shown_ary) {
			foreach ($shown_ary as $host) {
				$service_ids[$host['host']['name'].';'.$host['description']] = $host['last_state_change'];
			}
		}
		$new_data[$group] = array('timestamp' => time(), 'last_shown' => $service_ids);

		if (!isset($last_data[$group]) || !isset($last_data[$group]['timestamp']) || !isset($last_data[$group]['last_shown'])) {
			/* If $last_data isn't defined, make some data up, which prefferably would be right about now... */
			$last_data[$group] = array(
					'timestamp' => time(),
					'last_shown' => array()
					);
		}
		$data = $last_data[$group];
		$timestamp = $data['timestamp'];
		$last_shown = $data['last_shown'];
		foreach ($last_shown as $name => $_) {
			if (strpos($name, ';') === false)
				continue;
			list($host,$service) = explode(';', $name);
			$has_been_acked = $db->query(
				"SELECT COUNT(1) AS cnt FROM notification
				WHERE host_name = ".$db->escape($host)."
				AND service_description = ".$db->escape($service)."
				AND start_time > {$timestamp}
				AND ack_author IS NOT NULL");
			if ($has_been_acked->current()->cnt)
				unset($last_shown[$name]);
		}

		$svcsel = '';
		$all_services = array();

		$result_set = ServicePool_Model::all();
		/* @var $svcset ServiceSet_Model */

		if ($group && $group !== 'all') {
			$result_set = $result_set->reduce_by( 'groups', $group, '>=' );
			$first = true;
			foreach( $result_set->it($this->column_list,array($this->field .' '. $this->order)) as $elem ) {
				if (!$first)
					$svcsel .= ' OR ';
				$svcsel .= '(host_name = '.$db->escape($elem->get_host()->get_name()).' AND service_description = '.$db->escape($elem->get_description()).')';
				$first = false;
				$all_services[] = $elem->export();
			}
			$svcsel = 'AND ('.$svcsel.')';
		} else {
			foreach( $result_set->it($this->column_list,array($this->field .' '. $this->order)) as $elem ) {
				$all_services[] = $elem->export();
			}
		}

		$service_log = $db->query('
			SELECT event_type, state, hard, timestamp,
				host_name, service_description
			FROM report_data rd
			WHERE event_type IN (701, 1103, 1104) '.$svcsel.'
				AND rd.timestamp >= '.$timestamp);

		$new_services = array();
		$in_downtime = array();
		$in_interesting_state = array();
		foreach ($service_log as $obj) {
			// Check if service was in downtime last check
			// select both 1103 and 1104 to see which was last
			$init_downtime = $db->query("
				SELECT event_type
				FROM report_data
				WHERE timestamp < $timestamp
					AND event_type IN (1103, 1104)
					AND host_name = {$db->escape($obj->host_name)}
					AND service_description = {$db->escape($obj->service_description)}
				ORDER BY timestamp DESC
				LIMIT 1");
			if ($init_downtime->count())
				if ($init_downtime->current()->event_type == '1103')
					$in_downtime[$obj->host_name.';'.$obj->service_description] = true;

			switch ($obj->event_type) {
			 case 1103:
				$in_downtime[$obj->host_name.';'.$obj->service_description] = true;
				break;
			 case 1104:
				unset($in_downtime[$obj->host_name.';'.$obj->service_description]);
				if (isset($in_interesting_state[$obj->host_name.';'.$obj->service_description]))
					$new_services[$obj->host_name.';'.$obj->service_description] = $obj;
				break;
			 default:
				if ($this->arguments['hard'] && !$obj->hard)
					 break;
				if (!(1 << $obj->state & $this->state)) {
					unset($in_interesting_state[$obj->host_name.';'.$obj->service_description]);
					break;
				}
				$in_interesting_state[$obj->host_name.';'.$obj->service_description] = true;
				if (isset($in_downtime[$obj->host_name.';'.$obj->service_description]))
					break;
				$new_services[$obj->host_name.';'.$obj->service_description] = $obj;
				break;
			}
		}

		foreach ($new_services as $id => $obj) {
			$has_been_acked = $db->query(
				"SELECT COUNT(1) AS cnt FROM notification
				WHERE host_name = {$db->escape($obj->host_name)}
				AND service_description = {$db->escape($obj->service_description)}
				AND start_time > {$obj->timestamp}
				AND ack_author IS NOT NULL");
			if ($has_been_acked->current()->cnt)
				unset($new_services[$id]);
		}

		$filter = array();
		if ($group && $group != 'all')
			$filter = array('groups' => array('>=' => $group));
		$noticed = $this->get_all_noticed();
		$shown = array();
		foreach ($all_services as $row) {
			foreach ($shown_ary as $obj) {
				if ($obj['host']['name'] === $row['host']['name'] && $obj['description'] == $row['description']) {
					$shown[] = $row;
					continue 2;
				}
			}

			foreach ($new_services as $new => $obj) {
				if ($new == $row['host']['name'].';'.$row['description']) {
					if (!isset($noticed[$new]) || $noticed[$new] < $obj->timestamp) {
						$shown[] = $row;
					}
					continue 2;
				}
			}

			foreach ($last_shown as $key => $timestamp) {
				if ($key == $row['host']['name'].';'.$row['description']) {
					if (!isset($noticed[$key]) || $noticed[$key] < $timestamp) {
						$shown[] = $row;
					}
					continue 2;
				}
			}
		}
		$service_data = array();
		foreach ($shown as $service)
			$service_data[$service['host']['name'].';'.$service['description']] = $service['last_state_change'];
		$new_data[$group] = array('timestamp' => time(), 'last_shown' => $service_data);

		if (isset($this->arguments['grouplog'])) {
			$new_data = array_merge($this->arguments['grouplog'], $new_data);
		}

		$this->model->merge_settings(array('grouplog' => $new_data));
		$this->model->save();

		return $shown;
	}

	private function remove_service($service_id) {
		if (isset($this->model->setting['grouplog']) && isset($this->model->setting['grouplog'][$this->arguments['group']]) && isset($this->model->setting['grouplog'][$this->arguments['group']]['last_shown']))
			unset($this->model->setting['grouplog'][$this->arguments['group']]['last_shown'][$service_id]);
		if (!strpos($service_id, ';'))
			return;
		list($host, $service) = explode(';', $service_id);
		$db = new Database();
		$sql = "DELETE FROM widget_service_was_noticed WHERE host_name = {$db->escape($host)} AND service_description = {$db->escape($service)}";
		$db->query($sql);
		$sql = "INSERT INTO widget_service_was_noticed (host_name, service_description, timestamp) VALUES ({$db->escape($host)}, {$db->escape($service)}, UNIX_TIMESTAMP())";
		$db->query($sql);
	}

	public function options()
	{
		$options = parent::options();
		$options[] = new option('tac_services_unacknowledged', 'backlog', 'Backlog', 'checkbox', array(), false);
		$options[] = new option('tac_services_unacknowledged', 'hard', 'Hard', 'checkbox', array(), true);
		return $options;
	}

	public function index()
	{
		$view_path = $this->view_path('unack-view');

		$this->setup();

		if (isset($_GET['ack_service']))
			$this->remove_service($_GET['ack_service']);

		$this->props = nagstat::SERVICE_STATE_UNACKNOWLEDGED | nagstat::SERVICE_CHECKS_ENABLED | nagstat::HOST_NO_SCHEDULED_DOWNTIME;
		if ($this->arguments['hard'])
			$this->props |= nagstat::SERVICE_HARD_STATE;

		if ($this->arguments['backlog']) {
			$this->props &= ~(nagstat::SERVICE_HARD_STATE); // just because it's not in a hard state Right Now...
			$result = $this->get_all_since_last($this->arguments['group']);
		}
		else {
			// if we just stopped showing the problem backlog, throw away stale data
			if (isset($this->arguments['grouplog']) && !empty($this->arguments['grouplog'])) {
				$this->model->merge_settings(array('grouplog' => array()));
				$this->model->save();
			}
			$result = $this->service($this->arguments['group'], false, $this->state, $this->props, $this->order, $this->field, 'servicegroup');
		}

		$this->js[] = 'application/widgets/tac_services_unacknowledged/js/tac_services_unacknowledged';
		require($view_path);
	}
}
